<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <button (click)="newRow(modalForm)" class="btn btn-primary">
        <i class="fa fa-plus mr-2"></i>Nuevo
    </button>
    <!-- <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid.length">
        <i class="fas fa-file-pdf mr-2"></i>PDF
    </button> -->
</app-page-title>

<div class="main-card mb-3 card">
    <div class="card-body">
        <kendo-grid [kendoGridBinding]="dataGrid" [filter]="filter" filterable="menu" [selectable]="true"
            [navigable]="true" [reorderable]="true" [resizable]="true" [sortable]="true" [groupable]="false"
            [pageSize]="pageSize" [skip]="skip" [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
            (edit)="editRow($event, modalForm)" style="height: 74vh">
            <ng-container *ngFor="let item of gridFields">
                <kendo-grid-column [field]="item.dataKey" [title]="item.title" [width]="item.width"
                    [filterable]="item.filtro">
                    <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                        <ng-container *ngIf="column.field === 'fVenc' || column.field === 'fAlta'; else textField">
                            {{ dataItem[column.field] | date: formatKendo }}
                        </ng-container>
                        <ng-template #textField>
                            {{ dataItem[column.field] }}
                        </ng-template>
                    </ng-template>
                </kendo-grid-column>
            </ng-container>
            <kendo-grid-command-column title="Actions">
                <ng-template kendoGridCellTemplate let-isNew="isNew">
                    <button kendoGridEditCommand [primary]="true">Editar</button>
                </ng-template>
            </kendo-grid-command-column>
        </kendo-grid>
        <ngx-loading [show]="loading" [config]="loadingColor"></ngx-loading>
    </div>
</div>


<ng-template #modalForm let-modal let-c="close">
    <div class="modal-header">
        <div class="modal-title">
            <span *ngIf="!flagEdit">Nuevo</span>
            <span *ngIf="flagEdit">Editar</span>
        </div>
        <button class="close" aria-label="Close" (click)="modal.dismiss()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <form [formGroup]="myFormGroup" id="form">
            <div class="text-right">
                <button class="btn btn-danger" (click)="impRecibo(myFormGroup.value)" [disabled]="!flagEdit">
                    <i class="fas fa-file-pdf"></i> Imp. Recibo
                </button>
            </div>

            <div class="divider"></div>

            <div class="row d-flex justify-content-between">
                <div class="form-group col-2">
                    <label>Número</label>
                    <input type="number" class="form-control" formControlName="iNum" readonly>
                </div>
                <div class="form-group col-5">
                    <label>Artículo</label>
                    <kendo-combobox [data]="articulos" [textField]="'adesc'" [valueField]="'Articulo'"
                        [valuePrimitive]="true" formControlName="Articulo" class="w-100" [readonly]="flagEdit">
                    </kendo-combobox>
                </div>
                <div class="form-group col-5">
                    <label>Área</label>
                    <kendo-combobox [data]="areas" [textField]="'adesc'" [valueField]="'Area'" [valuePrimitive]="true"
                        formControlName="Area" class="w-100" [readonly]="flagEdit">
                    </kendo-combobox>
                </div>
            </div>
            <div class="row">
                <div class="form-group col-12">
                    <label>Notas</label>
                    <textarea rows="2" formControlName="cNotas" class="form-control" [readonly]="flagEdit"></textarea>
                </div>
            </div>
            <div class="row mt-1">
                <div class="form-group col-sm-6 col-md-6 col-lg-3">
                    <label class="w-100">Fecha</label>
                    <kendo-datepicker [format]="formatKendo" formControlName="fAlta" [readonly]="true">
                    </kendo-datepicker>
                </div>
                <div class="form-group col-sm-6 col-md-6 col-lg-3">
                    <label class="w-100">Fecha Vencimiento</label>
                    <kendo-datepicker [format]="formatKendo" formControlName="fVenc" [readonly]="flagEdit"
                        [min]="myFormGroup.value.fAlta">
                    </kendo-datepicker>
                </div>
                <div class="form-group col-sm-6 col-md-6 col-lg-3">
                    <label>Empleado</label>
                    <kendo-combobox [data]="empleados" [textField]="'enombre'" [valueField]="'Empleado'"
                        [valuePrimitive]="true" formControlName="Empleado" class="w-100" [readonly]="flagEdit">
                    </kendo-combobox>
                </div>
                <div class="form-group col-sm-6 col-md-6 col-lg-3">
                    <label>E.A.</label>
                    <kendo-dropdownlist [data]="estOper" [(ngModel)]="estatusOper" class="w-100" formControlName="ea"
                        [valuePrimitive]="true" [readonly]="myFormGroup.value.cEntOpe != ''">
                    </kendo-dropdownlist>
                </div>
                <div class="form-group col-8">
                    <label>Notas Entrega</label>
                    <input type="text" class="form-control" formControlName="cEntrega"
                        [attr.disabled]="estatusOper == 'Vigente' ||  estatusOper == null ? false : disabled"
                        [required]="flagEdit"
                        [value]="estatusOper == 'Vigente' ||  estatusOper == null ? '' : myFormGroup.value.cEntrega"
                        [readonly]="myFormGroup.value.cEntOpe != ''">
                </div>
                <div class="form-group col-2">
                    <label>Operador Entrega</label>
                    <input type="text" class="form-control" formControlName="cEntOpe" readonly="readonly">
                </div>
                <div class="form-group col-2">
                    <label>Operador</label>
                    <input type="text" class="form-control" formControlName="cOpe" readonly="readonly">
                </div>
            </div>
        </form>
    </div>
    <div class="modal-footer">
        <button class="btn btn-success mr-1"
            [disabled]="myFormGroup.status === 'INVALID' || estatusOper == 'Vigente' && cEntrega != '' && flagEdit || myFormGroup.value.cEntOpe != ''"
            (click)="guardarForm()">
            <i class="fas fa-save mr-2"></i>Guardar
        </button>
        <button class="btn btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>

<div #recibo hidden="hidden">
    <p>
        <em style="font-size: 14px;">{{ heading }}</em>
    </p>
    <p>
        <em style="font-size: 12px;">Numero: <strong>{{ myFormGroup.value.iNum }}</strong></em>
    </p>
    <p>
        <em style="font-size: 12px;"><span>Articulo: </span> {{ myFormGroup.value.cArticulo }}</em><br>
        <em style="font-size: 12px;"><span>Area: </span> {{ myFormGroup.value.cArea }}</em><br>
        <em style="font-size: 12px;"><span>Fecha: </span>
            {{ myFormGroup.value.fAlta | date:formatKendo }}
        </em><br>
        <em style="font-size: 12px;"><span>Empleado: </span> {{ myFormGroup.value.cEmpleado }}</em><br>
        <em style="font-size: 12px; padding-left: 50px;">
            <span>Notas:j</span>{{ myFormGroup.value.cNotas }}
        </em><br>
    </p>
    <p>&nbsp;</p>
    <p style="font-size: 12px; color: black;">
        Cuarto/Room:___________
        Nombre/Name:_____________________________________________
        Firma/Signature:______________________
    </p>
</div>